LeetCode_0001_两数之和

晓之以理动之以码.png

一,题目

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:

给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

二,题解

1,方案分析

  • 方案1:两次遍历暴力破解

    • ①遍历array找到num1
    • ②再次遍历array,根据条件num1+num2=target 找到num2
    • ③返回两数的下标
    • 复杂度分析:Time:O(n^2) Space:O(1)
  • 方案2:两遍哈希表

    • ①遍历array,将每个元素以<num,index>形式存储到HashMap中
    • ②再次遍历array,根据条件num1+num2=target 从map中找到num2
    • ③返回两数的下标
    • 复杂度分析:Time:O(n) Space:O(n)
  • 方案3:一遍哈希表

    • ①遍历array,根据条件num1+num2=target 从map中寻找num2
    • ②返回两数的下标
    • ③将每个元素以<num,index>形式存储到HashMap中
    • 复杂度分析:Time:O(n) Space:O(n)
  • 方案4:指针法(已排序array)

    • ①声明两个指针 left right 分别指向数组开始和末尾
    • ②如果左右指针在数组下标取值范围内就进入循环
    • ③根据num1+num2=target移动指针,直到找到
    • ④返回 left right的值
    • 复杂度分析:Time:O(n) Space:O(1)

2,代码实现

完整代码:Github

方案1:暴力法

测试代码:

    /**
     * Solution1: 暴力法
     * 暴力法很简单,遍历每个元素 x,并查找是否存在一个值与 target - x 相等的目标元素。
     *
     * <p>
     * 复杂度分析:
     * 时间复杂度:O(n^2)
     * 对于每个元素,都需要通过遍历数组的其余元素进行计算来寻找目标元素,这将耗费 O(n) 的时间。
     * 因此总的时间复杂度为 O(n^2)。
     *
     * 空间复杂度:O(1)
     * 未使用其它额外的变量存储
     *
     * 实际测试值:
     * 本环境测试:数组长度5:1000 ,数组长度5万:5 079 573
     * LeetCode:时间 22 ms    内存 36.5 MB
     */
    private static void solution1() {
        System.out.println("-----Solution1-----\n");
        //测试数据
        //随机数组
        int[] numArray = getNumArray();
        //获取随机下标
        int[] targetIndex = getTargetIndexFromArray(numArray);
        //生成target
        int target = numArray[targetIndex[0]] + numArray[targetIndex[1]];
        System.out.println("target:\n" + target);

        //暴力法测试
        //开始时间纳秒
        long sTime = System.nanoTime();
        //暴力法题解算法
        int[] resultIndex = new Solution().twoSum1(numArray, target);
        //结束时间纳秒
        long eTime = System.nanoTime();
        System.out.println("nanoTime:\n" + (eTime - sTime));

        printArray("resultIndex:", resultIndex);

    }

    /**
     * @param numArray 给定一个整数数组
     * @param target   给定一个目标值
     * @return 和为目标值的那两个整数的下标
     */
    public int[] twoSum1(int[] numArray, int target) {
        //条件检查
        if (numArray == null || numArray.length < 2) {
            return new int[2];
        }
        //数组中的每个元素和其它所有元素都计算一遍
        for (int i = 0; i < numArray.length; i++) {
            //j 从i+1开始可以减少不必要的时间复杂度,也避免重复
            for (int j = i + 1; j < numArray.length; j++) {
                //如果找到了和为目标值的那两个整数
                if (numArray[i] + numArray[j] == target) {
                    return new int[]{i, j};
                }
            }
        }
        //其它情况
        throw new IllegalArgumentException("No two sum solution");
    }

运行结果:

-----Solution1-----

numArray:
39, 74, 13, 57, 60
target:
70
nanoTime:
11725
resultIndex:
2, 3
-----Solution1-----

numArray:
5万条数据(请自行测试)
target:
1158586
nanoTime:
4 292 020
resultIndex:
20, 6461

方案2:两遍哈希表

测试代码:

    /**
     * Solution2: 两遍哈希表
     * <p>
     * 为了对运行时间复杂度进行优化,我们需要一种更有效的方法来检查数组中是否存在目标元素。如果存在,我们需要找出它的索引。
     * 保持数组中的每个元素与其索引相互对应的最好方法是什么?哈希表。
     *
     * <p>通过以空间换取速度的方式,我们可以将查找时间从 O(n) 降低到 O(1)。哈希表正是为此目的而构建的,
     * 它支持以 近似恒定的时间进行快速查找。我用“近似”来描述,是因为一旦出现冲突,查找用时可能会退化到 O(n)。
     * 但只要你仔细地挑选哈希函数,在哈希表中进行查找的用时应当被摊销为 O(1)。
     *
     * <p>一个简单的实现使用了两次迭代。
     * 在第一次迭代中,我们将每个元素的值和它的索引添加到表中。
     * 在第二次迭代中,我们将检查每个元素所对应的目标元素(target -nums[i])是否存在于表中。
     * 注意,该目标元素不能是 nums[i]本身!
     *
     * 复杂度分析:
     * 时间复杂度:O(n)
     * 我们把包含有 n 个元素的列表遍历两次。由于哈希表将查找时间缩短到 O(1) ,所以时间复杂度为O(n)。
     * 空间复杂度:O(n)
     * 所需的额外空间取决于哈希表中存储的元素数量,该表中存储了 n个元素
     *
     * 实际测试值:
     * 本环境测试:数组长度5:60000 ,数组长度5万:1 369 711
     * LeetCode:时间 4 ms 内存 36.6 MB
     *
     */
    private static void solution2() {
        System.out.println("-----Solution2-----\n");
        //测试数据
        //随机数组
        int[] numArray = getNumArray();
        //获取随机下标
        int[] targetIndex = getTargetIndexFromArray(numArray);
        //生成target
        int target = numArray[targetIndex[0]] + numArray[targetIndex[1]];
        System.out.println("target:\n" + target);

        //开始时间
        long sTime = System.nanoTime();
        //两遍哈希表题解算法
        int[] resultIndex = new Solution().twoSum2(numArray, target);
        //结束时间
        long eTime = System.nanoTime();
        System.out.println("nanoTime:\n" + (eTime - sTime));

        printArray("resultIndex:", resultIndex);

    }

    /**
     * @param numArray 给定一个整数数组
     * @param target   给定一个目标值
     * @return 和为目标值的那两个整数的下标
     */
    public int[] twoSum2(int[] numArray, int target) {
        // 条件检查
        if (numArray == null || numArray.length < 2) {
            return new int[2];
        }
        //初始化一个HashMap
        Map<Integer, Integer> numMap = new HashMap<>();
        //将数组中<元素,下标> 转化为Map中的<key,value>
        for (int i = 0; i < numArray.length; i++) {
            numMap.put(numArray[i], i);
        }
        //遍历整个数组,找到每个元素
        for (int firstIndex = 0; firstIndex < numArray.length; firstIndex++) {
//            //方式一 secondIndex
//            //根据两数之和为target尝试获取secondIndex
//            Integer secondIndex = numMap.get(target - numArray[firstIndex]);
//            //如果找到了secondIndex并且secondIndex != firstIndex
//            if (secondIndex != null && secondIndex != firstIndex) {
//                return new int[]{firstIndex, secondIndex};
//            }

            //方式二 secondNum
            //根据两数之和为target获取 secondNum
            int secondNum = target - numArray[firstIndex];
            //如果map中包含secondNum并且 secondNum != firstNum
            if (numMap.containsKey(secondNum) && numMap.get(secondNum) != firstIndex) {
                return new int[]{firstIndex, numMap.get(secondNum)};
            }

        }

        //其它情况
        throw new IllegalArgumentException("No two sum solution");
    }

运行结果:

-----Solution2-----

numArray:
30, 28, 92, 60, 29
target:
152
nanoTime:
90198
resultIndex:
2, 3
-----Solution2-----

numArray:
5万条数据(请自行测试)
target:
1477048
nanoTime:
15 190 543
resultIndex:
7, 46604

方案3:一遍哈希表

测试代码:

 /**
     * Solution3: 一遍哈希表
     * 事实证明,我们可以一次完成。在进行迭代并将元素插入到表中的同时,
     * 我们还会回过头来检查表中是否已经存在当前元素所对应的目标元素。
     * 如果它存在,那我们已经找到了对应解,并立即将其返回。
     *
     * 复杂度分析:
     * 时间复杂度:O(n)
     * 我们只遍历了包含有 nn 个元素的列表一次。在表中进行的每次查找只花费 O(1)O(1) 的时间
     * 空间复杂度:O(n)
     * 所需的额外空间取决于哈希表中存储的元素数量,该表中存储了 n个元素
     *
     * 实际测试值:
     * 本环境测试:数组长度5:50000 ,数组长度5万:1 307 594
     * LeetCode:时间 3 ms 内存 37.8 MB
     */
    private static void solution3() {
        System.out.println("-----Solution3-----\n\n");
        //测试数据
        //随机数组
        int[] numArray = getNumArray();
        //获取随机下标
        int[] targetIndex = getTargetIndexFromArray(numArray);
        //生成target
        int target = numArray[targetIndex[0]] + numArray[targetIndex[1]];
//        int target = 6;
        System.out.println("target:\n" + target);

        //开始时间
        long sTime = System.nanoTime();
        //一遍哈希表题解算法
        int[] resultIndex = new Solution().twoSum3(numArray, target);
        //结束时间
        long eTime = System.nanoTime();
        System.out.println("nanoTime:\n" + (eTime - sTime));

        printArray("resultIndex:", resultIndex);

    }

    /**
     * @param numArray 给定一个整数数组
     * @param target   给定一个目标值
     * @return 和为目标值的那两个整数的下标
     */
    public int[] twoSum3(int[] numArray, int target) {
        // 条件检查
        if (numArray == null || numArray.length < 2) {
            return new int[2];
        }
        //初始化一个HashMap
        Map<Integer, Integer> numMap = new HashMap<>();
        //将数组中<元素,下标> 转化为Map中的<key,value>
        for (int firstIndex = 0; firstIndex < numArray.length; firstIndex++) {
            //方式一 secondIndex
//            //根据两数之和为target尝试获取secondIndex
//            Integer secondIndex = numMap.get(target - numArray[firstIndex]);
//            //如果找到了secondIndex 此时的secondIndex肯定不会和firstIndex相等的
//            if (secondIndex != null) {
//                return new int[]{firstIndex, secondIndex};
//            }

            //方式二 secondNum
            //根据两数之和为target获取 secondNum
            int secondNum = target - numArray[firstIndex];
            //如果map中包含secondNum
            if (numMap.containsKey(secondNum) && numMap.get(secondNum) != firstIndex) {
                return new int[]{firstIndex, numMap.get(secondNum)};
            }

            numMap.put(numArray[firstIndex], firstIndex);

        }

        //其它情况
        throw new IllegalArgumentException("No two sum solution");
    }

运行结果:

-----Solution3-----


numArray:
48, 26, 13, 29, 92
target:
42
nanoTime:
72273
resultIndex:
3, 2
-----Solution3-----

numArray:
5万条数据(请自行测试)
target:
1439732
nanoTime:
1 179 748
resultIndex:
719, 250

方案4:指针法(已排序array)

测试代码:

/**
     * Solution4: 排序+指针 (该方案不能通过LeetCode,下标错乱)
     * 如果给定的数据是已经排序的,我们可以通过移动指针来寻找和为目标值的那两个元素,使用指针可以避免使用额外的内存开销
     * <p>
     * 复杂度分析:
     * 时间复杂度:O(n)
     * 最坏的情况我们的while循环会遍历所有,所以时间复杂度为O(n)
     * 空间复杂度:O(1)
     * 所需的额外空间取决于哈希表中存储的元素数量,该表中存储了 n个元素
     * <p>
     * 实际测试值:
     * 本环境测试:数组长度5:10535 ,数组长度5万:47 321
     */
    private static void solution4() {
        System.out.println("-----Solution4-----\n\n");
        //测试数据
        //随机数组
        int[] numArray = getNumArray();
        //获取随机下标
        int[] targetIndex = getTargetIndexFromArray(numArray);
        //生成target
        int target = numArray[targetIndex[0]] + numArray[targetIndex[1]];
//        int target = 6;
        System.out.println("target:\n" + target);

        //对数组排序
        Arrays.sort(numArray);
        printArray("sorted numArray:", numArray);

        //开始时间
        long sTime = System.nanoTime();
        //排序+指针题解算法
        int[] resultIndex = new Solution().twoSum4(numArray, target);
        //结束时间
        long eTime = System.nanoTime();
        System.out.println("nanoTime:\n" + (eTime - sTime));

        printArray("resultIndex:", resultIndex);

    }

    /**
     * @param numArray 给定一个整数数组
     * @param target   给定一个目标值
     * @return 和为目标值的那两个整数的下标
     */
    public int[] twoSum4(int[] numArray, int target) {
        // 条件检查
        if (numArray == null || numArray.length < 2) {
            return new int[2];
        }

        //左指针初始指向第一个元素
        int left = 0;
        //右指针初始指向最后一个元素
        int right = numArray.length - 1;
        //如果左右指针在数组下标取值范围内就进入循环
        while ((left > -1 && left < numArray.length) && (right > -1 && right < numArray.length)) {
            //计算当前左右指针所指向的元素的和
            int tempTarget = numArray[left] + numArray[right];
            //当前得到的tempTarget小于target,右指针是最大了,所以需要将左指针向右增大移动
            if (tempTarget < target) {
                left++;
            }
            //当前得到的tempTarget大于target,左指针是最小了,所以需要将右指针向左减小移动
            else if (tempTarget > target) {
                right--;
            }
            //tempTarget等于target,找到了目标值
            else {
                return new int[]{left, right};
            }

        }

        //其它情况
        throw new IllegalArgumentException("No two sum solution");
    }

运行结果:

-----Solution4-----


numArray:
11, 86, 64, 75, 68
target:
150
sorted numArray:
11, 64, 68, 75, 86
nanoTime:
9675
resultIndex:
1, 4
-----Solution3-----

numArray:
5万条数据(请自行测试)
target:
680708
nanoTime:
580 795
resultIndex:
17, 33852
最后编辑于
©著作权归作者所有,转载或内容合作请联系作者
  • 序言:七十年代末,一起剥皮案震惊了整个滨河市,随后出现的几起案子,更是在滨河造成了极大的恐慌,老刑警刘岩,带你破解...
    沈念sama阅读 203,324评论 5 476
  • 序言:滨河连续发生了三起死亡事件,死亡现场离奇诡异,居然都是意外死亡,警方通过查阅死者的电脑和手机,发现死者居然都...
    沈念sama阅读 85,303评论 2 381
  • 文/潘晓璐 我一进店门,熙熙楼的掌柜王于贵愁眉苦脸地迎上来,“玉大人,你说我怎么就摊上这事。” “怎么了?”我有些...
    开封第一讲书人阅读 150,192评论 0 337
  • 文/不坏的土叔 我叫张陵,是天一观的道长。 经常有香客问我,道长,这世上最难降的妖魔是什么? 我笑而不...
    开封第一讲书人阅读 54,555评论 1 273
  • 正文 为了忘掉前任,我火速办了婚礼,结果婚礼上,老公的妹妹穿的比我还像新娘。我一直安慰自己,他们只是感情好,可当我...
    茶点故事阅读 63,569评论 5 365
  • 文/花漫 我一把揭开白布。 她就那样静静地躺着,像睡着了一般。 火红的嫁衣衬着肌肤如雪。 梳的纹丝不乱的头发上,一...
    开封第一讲书人阅读 48,566评论 1 281
  • 那天,我揣着相机与录音,去河边找鬼。 笑死,一个胖子当着我的面吹牛,可吹牛的内容都是我干的。 我是一名探鬼主播,决...
    沈念sama阅读 37,927评论 3 395
  • 文/苍兰香墨 我猛地睁开眼,长吁一口气:“原来是场噩梦啊……” “哼!你这毒妇竟也来了?” 一声冷哼从身侧响起,我...
    开封第一讲书人阅读 36,583评论 0 257
  • 序言:老挝万荣一对情侣失踪,失踪者是张志新(化名)和其女友刘颖,没想到半个月后,有当地人在树林里发现了一具尸体,经...
    沈念sama阅读 40,827评论 1 297
  • 正文 独居荒郊野岭守林人离奇死亡,尸身上长有42处带血的脓包…… 初始之章·张勋 以下内容为张勋视角 年9月15日...
    茶点故事阅读 35,590评论 2 320
  • 正文 我和宋清朗相恋三年,在试婚纱的时候发现自己被绿了。 大学时的朋友给我发了我未婚夫和他白月光在一起吃饭的照片。...
    茶点故事阅读 37,669评论 1 329
  • 序言:一个原本活蹦乱跳的男人离奇死亡,死状恐怖,灵堂内的尸体忽然破棺而出,到底是诈尸还是另有隐情,我是刑警宁泽,带...
    沈念sama阅读 33,365评论 4 318
  • 正文 年R本政府宣布,位于F岛的核电站,受9级特大地震影响,放射性物质发生泄漏。R本人自食恶果不足惜,却给世界环境...
    茶点故事阅读 38,941评论 3 307
  • 文/蒙蒙 一、第九天 我趴在偏房一处隐蔽的房顶上张望。 院中可真热闹,春花似锦、人声如沸。这庄子的主人今日做“春日...
    开封第一讲书人阅读 29,928评论 0 19
  • 文/苍兰香墨 我抬头看了看天上的太阳。三九已至,却和暖如春,着一层夹袄步出监牢的瞬间,已是汗流浃背。 一阵脚步声响...
    开封第一讲书人阅读 31,159评论 1 259
  • 我被黑心中介骗来泰国打工, 没想到刚下飞机就差点儿被人妖公主榨干…… 1. 我叫王不留,地道东北人。 一个月前我还...
    沈念sama阅读 42,880评论 2 349
  • 正文 我出身青楼,却偏偏与公主长得像,于是被迫代替她去往敌国和亲。 传闻我的和亲对象是个残疾皇子,可洞房花烛夜当晚...
    茶点故事阅读 42,399评论 2 342